package main

import (
	"converge/pkg/server/templates"
	"math/rand"
	"net/http"
	"os"
	"strconv"
	"strings"
)

func generateCLIExammple(w http.ResponseWriter, r *http.Request) {
	err := r.ParseForm()
	if err != nil {
		http.Error(w, "Error parsing form", http.StatusBadRequest)
		return
	}
	ids := r.Form["rendez-vous-id"]
	id := ""
	if len(ids) > 0 {
		id = ids[0]
	}
	if id == "" {
		id = strconv.Itoa(rand.Int() % 1000000)
	}
	remoteShells := r.Form["remote-shell"]
	localShells := r.Form["local-shell"]
	keysString := r.FormValue("ssh-keys")
	sshPublicKeys := make([]string, 0)
	for _, line := range strings.Split(keysString, "\n") {
		line := strings.TrimSpace(line)
		if line != "" {
			sshPublicKeys = append(sshPublicKeys, line)
		}
	}
	access := getConvergeAccess(r, getAgentSshUser())

	usageInputs := templates.NewUsageInputs(id, sshPublicKeys, remoteShells, localShells)
	err = templates.ShellUsage(access, usageInputs).Render(r.Context(), w)
	if err != nil {
		http.Error(w, err.Error(), 500)
	}
}

func getAgentSshUser() string {
	username, _ := os.LookupEnv("CONVERGE_USERNAME")
	return username
}
